<template>
	<view
	    :style="[style]"
	    class="uv-status-bar"
	>
		<slot />
	</view>
</template>

<script>
	import mpMixin from '@/uni_modules/uv-ui-tools/libs/mixin/mpMixin.js'
	import mixin from '@/uni_modules/uv-ui-tools/libs/mixin/mixin.js'
	import props from './props.js';
	/**
	 * StatbusBar 狀態欄占位
	 * @description 本組件主要用於狀態填充，比如在自定導航欄的時候，它會自動適配壹個恰當的狀態欄高度。
	 * @tutorial https://www.uvui.cn/components/statusBar.html
	 * @property {String}			bgColor			背景色 (默認 'transparent' )
	 * @property {String | Object}	customStyle		自定義樣式 
	 * @example <uv-status-bar></uv-status-bar>
	 */
	export default {
		name: 'uv-status-bar',
		mixins: [mpMixin, mixin, props],
		data() {
			return {
			}
		},
		computed: {
			style() {
				const style = {}
				// 狀態欄高度，由於某些安卓和微信開發工具無法識別css的頂部狀態欄變量，所以使用js獲取的方式
				style.height = this.$uv.addUnit(this.$uv.sys().statusBarHeight, 'px')
				if(this.bgColor){
					if (this.bgColor.indexOf("gradient") > -1) {// 漸變色
						style.backgroundImage = this.bgColor;
					}else{
						style.background = this.bgColor;
					}
				}
				return this.$uv.deepMerge(style, this.$uv.addStyle(this.customStyle))
			}
		},
	}
</script>

<style lang="scss" scoped>
	.uv-status-bar {
		// nvue會默認100%，如果nvue下，顯式寫100%的話，會導致寬度不為100%而異常
		/* #ifndef APP-NVUE */
		width: 100%;
		/* #endif */
	}
</style>
